<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:gri="http://java.sun.com/jsf/composite/gri">
    <div class="form-horizontal">
        <a4j:region>
            <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                <ui:define name="label">#{messages['net.ihe.gazelle.hpd.OrganizationalUnit']}</ui:define>
                <ui:param name="id" value="nodeIn"/>
                <h:selectOneMenu value="#{currentRequest.selectedNode}" id="nodeIn"
                                 styleClass="form-control gzl-select-text">
                    <s:selectItems value="#{providerInformationSource.getAvailableNodes()}" var="n" label="#{n.name}"
                                   noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                    <a4j:ajax event="change" render="requestConfPanel" execute="@this"
                              listener="#{providerInformationSource.onNodeSelected(currentRequest)}"/>
                </h:selectOneMenu>
            </s:decorate>
        </a4j:region>
        <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="dnToModify"
                    rendered="#{currentRequest.selectedNode != null}">
            <ui:param name="id" value="dnIn"/>
            <ui:define name="label">#{messages['net.ihe.gazelle.hpd.DNOfTheEntryToModify']}</ui:define>
            <h:inputText value="#{currentRequest.request.dn}" id="dnIn" styleClass="form-control"/>
        </s:decorate>
    </div>
    <s:div id="modificationDiv" rendered="#{currentRequest.selectedNode != null}">
        <h3>#{messages['net.ihe.gazelle.hpd.Modifications']}</h3>
        <gri:panel styleClass="panel-info">
            <f:facet name="header">New modification</f:facet>
            <div class="form-inline">
                <ui:decorate template="/layout/form/_edit.xhtml">
                    <ui:param name="id" value="attrName"/>
                    <ui:define name="label">Attribute's name</ui:define>
                    <rich:autocomplete mode="client"
                                       autocompleteList="#{currentReq.getAvailableAttributeTypes()}"
                                       value="#{currentRequest.dsmlModification.name}" minChars="1" autofill="false"
                                       selectFirst="false"
                                       id="attrName" layout="list"/>
                </ui:decorate>
                <ui:decorate template="/layout/form/_edit.xhtml">
                    <ui:param name="id" value="opIn"/>
                    <ui:define name="label">Operation</ui:define>
                    <h:selectOneMenu value="#{currentRequest.dsmlModification.operation}"
                                     id="opIn" styleClass="form-control">
                        <f:selectItems value="#{providerInformationSource.availableOperations}"/>
                    </h:selectOneMenu>
                </ui:decorate>
                <ui:decorate template="/layout/form/_edit.xhtml">
                    <ui:param name="id" value="attrValue"/>
                    <ui:define name="label">Value</ui:define>
                    <h:inputText value="#{currentRequest.value}" styleClass="form-control" id="attrValue"/>
                </ui:decorate>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.AddModification']}" styleClass="gzl-btn-blue"
                                   actionListener="#{currentRequest.addDsmlModification()}"
                                   render="modificationDiv"/>
            </div>
        </gri:panel>
        <rich:dataTable value="#{currentRequest.request.modification}" var="modif"
                        id="modificationTable">
            <g:column>
                <ui:define name="header">#{messages['net.ihe.gazelle.hpd.AttributesName']}</ui:define>
                <h:outputText value="#{modif.name}"/>
            </g:column>
            <g:column>
                <ui:define name="header">#{messages['net.ihe.gazelle.hpd.Operation']}</ui:define>
                <h:outputText value="#{modif.operation.value()}"/>
            </g:column>
            <g:column>
                <ui:define name="header">#{messages['net.ihe.gazelle.hpd.Values']})</ui:define>
                <a4j:repeat value="#{modif.valuesForGui}" var="gval">
                    <div class="row">
                        <div class="col-md-8">
                            <h:inputText value="#{gval.guiValue}" size="90" styleClass="form-control"/>
                        </div>
                        <div class="col-md-2">
                            <a4j:commandLink
                                    action="#{providerInformationSource.removeValueFromDsmlModification(gval,modif)}"
                                    title="#{messages['net.ihe.gazelle.hpd.RemoveThisValue']}"
                                    render="modificationTable">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </div>
                    </div>
                </a4j:repeat>
            </g:column>
            <g:column>
                <ui:define name="header">#{messages['users.Action']}</ui:define>
                <a4j:commandLink title="#{messages['net.ihe.gazelle.hpd.AddAValue']}" render="modificationTable"
                                 rendered="#{not currentRequest.isAttributeSingleValue(modif.name)}"
                                 actionListener="#{providerInformationSource.addValueToDsmlModification(modif)}">
                    <s:span styleClass="gzl-icon-plus"/>
                </a4j:commandLink>
                <a4j:commandLink title="#{messages['net.ihe.gazelle.hpd.RemoveFromList']}"
                                 render="modificationTable"
                                 actionListener="#{currentRequest.removeDsmlModification(modif)}">
                    <s:span styleClass="gzl-icon-trash-o"/>
                </a4j:commandLink>
            </g:column>
        </rich:dataTable>
    </s:div>
</ui:composition>
